# $Id: xchain-glibc.make,v 0.3.2.1 2002/09/13 11:40:00 robert Exp $
#
# (c) 2002 by Pengutronix e.K., Hildesheim, Germany
# See CREDITS for details about who has contributed to this project. 
#
# For further information about the PTXDIST project and license conditions
# see the README file.
#

#
# We provide this package
#
PACKAGES += glibc

#
# Paths and names 
#
GLIBC			= glibc-2.2.5
GLIBC_URL		= ftp://ftp.gnu.org/gnu/glibc/$(GLIBC).tar.gz
GLIBC_SOURCE		= $(SRCDIR)/$(GLIBC).tar.gz
GLIBC_DIR		= $(BUILDDIR)/$(GLIBC)
GLIBC_EXTRACT 		= gzip -dc

GLIBC_THREADS		= glibc-linuxthreads-2.2.5
GLIBC_THREADS_URL	= ftp://ftp.gnu.org/gnu/glibc/glibc-linuxthreads-2.2.5.tar.gz
GLIBC_THREADS_SOURCE	= $(SRCDIR)/$(GLIBC_THREADS).tar.gz
GLIBC_THREADS_DIR	= $(GLIBC_DIR)
GLIBC_THREADS_EXTRACT	= gzip -dc

GLIBC_ARM		= patch-glibc-2.2.5-ptx1
GLIBC_ARM_URL		= http://www.pengutronix.de/software/dnp/patch-glibc-2.2.5-ptx1
GLIBC_ARM_SOURCE	= $(SRCDIR)/$(GLIBC_ARM)
GLIBC_ARM_DIR		= $(GLIBC_DIR)
GLIBC_ARM_EXTRACT	= cat 

# ----------------------------------------------------------------------------
# Get
# ----------------------------------------------------------------------------

glibc_get: $(STATEDIR)/glibc.get

glibc_get_deps =  $(GLIBC_SOURCE)
ifdef CONFIG_PTX_GLIBC_PTHREADS
glibc_get_deps += $(GLIBC_THREADS_SOURCE)
endif
ifdef CONFIG_PTX_ARCH_ARM
glibc_get_deps += $(GLIBC_ARM_SOURCE)
endif

$(STATEDIR)/glibc.get: $(glibc_get_deps)
	touch $@

$(GLIBC_SOURCE):
	@echo
	@echo --------- 
	@echo glibc.get
	@echo ---------
	@echo
	wget -P $(SRCDIR) $(PASSIVEFTP) $(GLIBC_URL)

$(GLIBC_THREADS_SOURCE):
	@echo
	@echo ----------------- 
	@echo glibc-threads.get
	@echo -----------------
	@echo
	wget -P $(SRCDIR) $(PASSIVEFTP) $(GLIBC_THREADS_URL)

$(GLIBC_ARM_SOURCE):
	@echo
	@echo ------------- 
	@echo glibc-arm.get
	@echo -------------
	@echo
	wget -P $(SRCDIR) $(PASSIVEFTP) $(GLIBC_ARM_URL)

# ----------------------------------------------------------------------------
# Extract
# ----------------------------------------------------------------------------

glibc_extract: $(STATEDIR)/glibc.extract

glibc_extract_deps =  $(STATEDIR)/glibc-base.extract
ifdef CONFIG_PTX_GLIBC_PTHREADS
glibc_extract_deps += $(STATEDIR)/glibc-threads.extract
endif
ifdef CONFIG_PTX_ARCH_ARM
glibc_extract_deps += $(STATEDIR)/glibc-arm.extract
endif

$(STATEDIR)/glibc.extract: $(glibc_extract_deps)
	touch $@

$(STATEDIR)/glibc-base.extract: $(STATEDIR)/glibc.get
	@echo
	@echo ------------------ 
	@echo glibc-base.extract
	@echo ------------------
	@echo
	$(GLIBC_EXTRACT) $(GLIBC_SOURCE) | $(TAR) -C $(BUILDDIR) -xf -
	touch $@

$(STATEDIR)/glibc-threads.extract: $(STATEDIR)/glibc.get
	@echo
	@echo --------------------- 
	@echo glibc-threads.extract
	@echo ---------------------
	@echo
	$(GLIBC_THREADS_EXTRACT) $(GLIBC_THREADS_SOURCE) | $(TAR) -C $(GLIBC_DIR) -xf -
	touch $@

$(STATEDIR)/glibc-arm.extract: $(STATEDIR)/glibc.get
	@echo
	@echo ----------------- 
	@echo glibc-arm.extract
	@echo -----------------
	@echo
	cd $(GLIBC_DIR) && patch -p1 < $(GLIBC_ARM_SOURCE)
	# this is magically recreated if missing (necessary because
	# of patch against configure.in)
	rm -f $(GLIBC_DIR)/sysdeps/unix/sysv/linux/configure
	touch $@

# ----------------------------------------------------------------------------
# Prepare
# ----------------------------------------------------------------------------

glibc_prepare: $(STATEDIR)/glibc.prepare 

# ifdef CONFIG_PTX_GLIBC
# ifdef CONFIG_PTX_ARCH_ARM
#   GLIBC_AUTOCONF+=--host=arm-linux
#   GLIBC_ENVIRONMENT=CC=arm-linux-gcc
# endif
# ifdef CONFIG_PTX_GLIBC_FLOATINGPOINT
#   GLIBC_AUTOCONF+=--with-fp=yes
# else
#   GLIBC_AUTOCONF+=--with-fp=no
# endif
# ifdef CONFIG_PTX_GLIBC_LIBIO
#   GLIBC_AUTOCONF+=--enable-libio
# endif
# ifdef CONFIG_PTX_GLIBC_SHARED
#   GLIBC_AUTOCONF+=--enable-shared=yes
# else
#   GLIBC_AUTOCONF+=--enalbe-shared=no
# endif
# ifdef CONFIG_PTX_GLIBC_PROFILED
#   GLIBC_AUTOCONF+=--enable-profile=yes
# else
#   GLIBC_AUTOCONF+=--enable-profile=no
# endif
# ifdef CONFIG_PTX_GLIBC_OMITFP
#   GLIBC_AUTOCONF+=--enable-omitfp
# endif
# ifdef CONFIG_PTX_GLIBC_PTHREADS
#   GLIBC_AUTOCONF+=--enable-add-ons=linuxthreads
# endif
# ifdef CONFIG_PTX_OPT_I386
#   GLIBC_AUTOCONF+=--host=i386-pc-linux-gnu
# endif
# ifdef CONFIG_PTX_OPT_I686
#   GLIBC_AUTOCONF+=--host=i686-pc-linux-gnu
# endif
# GLIBC_AUTOCONF+=--prefix=/usr
# GLIBC_AUTOCONF+=--with-headers=$(BUILDDIR)/linux/include
# ifdef CONFIG_PTX_OPT_I386
#   GLIBC_CFLAGS+=-mcpu=i386 -O2
# endif
# ifdef CONFIG_PTX_OPT_I686
#   GLIBC_CFLAGS+=-mcpu=i686 -O2
# endif
# ifdef CONFIG_PTX_ARCH_ARM
#   GLIBC_CFLAGS+=-O2 -Wall -pipe
# endif
# endif

glibc_prepare_deps =  $(STATEDIR)/glibc.extract 
glibc_prepare_deps += $(STATEDIR)/xchain-gccstage1.install
glibc_prepare_deps += $(STATEDIR)/xchain-kernel.prepare

$(STATEDIR)/glibc.prepare: $(glibc_prepare_deps)
	@echo
	@echo ------------- 
	@echo glibc.prepare
	@echo -------------
	@echo
	mkdir -p $(BUILDDIR)/$(GLIBC)-obj 
	cd $(BUILDDIR)/$(GLIBC)-obj &&					\
	        PATH=$(CONFIG_PTX_CROSSCHAIN_PREFIX)/bin:$$PATH		\
	       	AR=$(CONFIG_PTX_GNU_TARGET)-ar				\
        	RANLIB=$(CONFIG_PTX_GNU_TARGET)-ranlib			\
        	CC=$(CONFIG_PTX_GNU_TARGET)-gcc				\
        	$(GLIBC_DIR)/configure $(CONFIG_PTX_GNU_TARGET)		\
		--build=i686-linux					\
		--target=$(CONFIG_PTX_GNU_TARGET)			\
		--prefix=$(CONFIG_PTX_CROSSCHAIN_PREFIX)		\
		--enable-add-ons					\
		--with-headers=$(KERNEL_DIR)/include			\
		--disable-sanity-checks
	# 
	# we need a second directory where we configure glibc for the 
	# dynamic linker 
	#
	mkdir -p $(BUILDDIR)/$(GLIBC)-ldso
	cd $(BUILDDIR)/$(GLIBC)-ldso &&					\
		PATH=$(CONFIG_PTX_CROSSCHAIN_PREFIX)/bin:$$PATH		\
		AR=$(CONFIG_PTX_GNU_TARGET)-ar				\
		RANLIB=$(CONFIG_PTX_GNU_TARGET)-ranlib			\
		CC=$(CONFIG_PTX_GNU_TARGET)-gcc				\
		$(GLIBC_DIR)/configure $(CONFIG_PTX_GNU_TARGET)		\
		--build=i686-linux					\
		--target=$(CONFIG_PTX_GNU_TARGET)			\
		--prefix=						\
		--enable-add-ons					\
		--with-headers=$(KERNEL_DIR)/include			\
		--disable-sanity-checks	
	touch $@

# ----------------------------------------------------------------------------
# Compile
# ----------------------------------------------------------------------------

glibc_compile: $(STATEDIR)/glibc.compile

$(STATEDIR)/glibc.compile: $(STATEDIR)/glibc.prepare 
	@echo
	@echo ------------- 
	@echo "glibc.compile (obj)"
	@echo -------------
	@echo
	PATH=$(CONFIG_PTX_CROSSCHAIN_PREFIX)/bin:$$PATH 		\
		make -C $(BUILDDIR)/$(GLIBC)-obj 
	@echo
	@echo -------------
	@echo "glibc.compile (ld-so)"
	@echo -------------
	@echo
	PATH=$(CONFIG_PTX_CROSSCHAIN_PREFIX)/bin:$$PATH			\
		make -C $(BUILDDIR)/$(GLIBC)-ldso
	touch $@

# ----------------------------------------------------------------------------
# Install
# ----------------------------------------------------------------------------

glibc_install: $(STATEDIR)/glibc.install

$(STATEDIR)/glibc.install: $(STATEDIR)/glibc.compile
	@echo
	@echo ------------- 
	@echo glibc.install
	@echo -------------
	@echo
	PATH=$(CONFIG_PTX_CROSSCHAIN_PREFIX)/bin:$$PATH 		\
		make -C $(BUILDDIR)/$(GLIBC)-obj install
	# CAREFUL: don't never ever make install in ldso tree!!!
	mkdir -p $(ROOTDIR)/lib
	cp $(BUILDDIR)/$(GLIBC)-ldso/elf/ld.so $(ROOTDIR)/lib/ld-linux.so.2
	touch $@

# ----------------------------------------------------------------------------
# Clean
# ----------------------------------------------------------------------------

glibc_clean: 
	rm -rf $(STATEDIR)/glibc* 
	rm -rf $(GLIBC_DIR) 
	rm -rf $(BUILDDIR)/$(GLIBC)-obj 
	rm -rf $(BUILDDIR)/$(GLIBC)-ldso

# vim: syntax=make
